﻿
if (jQuery) (
function (jQuery) {
    jQuery.extend(jQuery.fn, {
        tablePaging: function (options) {
            jQuery(this).each(function () {
                settings = jQuery.extend({
                    id: jQuery(this).attr('id'), // The ID of the object being paging
                    pageSize: 10, // The size of one page
                    sorting: false,
                    sortDirection: 'desc', // asc & desc
                    sortSelector: '',
                    sortType: '', //number,string,date
                    trId: '',
                    total: 0,
                    onPaged: null // // Function to run after paged
                }, options);
            });
            $(this).each(function () {
            	if (settings.sorting) {
                    jQuery(this).tableSort(settings.sortSelector, settings.sortType, settings.sortDirection, settings.total);

                }
                var pageSize = parseInt(settings.pageSize);

                //var trResult = jQuery('#' + jQuery(this).attr('id')).find('tbody:first tr');
                var trLen = parseInt(settings.total);
                var pageIndex = 0;
                if (!jQuery(this).data("pageindex")) {
                    jQuery(this).data("pageindex", "0");
                };
                pageIndex = parseInt(jQuery(this).data("pageindex"));
                if (pageIndex * pageSize == trLen) pageIndex = pageIndex - 1; // make sure the last page will show right
                /*jQuery('#' + jQuery(this).attr('id')).find('tbody').each(function (i, element) {
                    var trs = $(this).find('tr');
                    var trsLen = trs.length;
                    trs.hide();
                });*/
                for(var i = 0; i < trLen; i++){
                	var queryTr = $('#selectOnly'+i.toString());
                	var nextId = $('#selectOnly'+i.toString()).next("tr").attr("id");
            		$('#selectOnly'+i).hide();
            		//Hide the detail info if it's explored
            		$('#' + settings.id + 'Tr' + i).hide();
            		if(i >= pageIndex * pageSize && i < (pageIndex + 1) * pageSize){
            			$('#selectOnly'+i).show();
            			if(getCookie("state_" + nextId) == 'visible'){
            				$('#' + nextId).show();
            			}
            		}
                }

                var allPage = Math.ceil(parseInt(trLen) / pageSize);
                //if (allPage > 1) {
                    jQuery("#" + jQuery(this).attr('id') + "Paging").remove();
                    jQuery("#" + jQuery(this).attr('id')).after('<div id="' + jQuery(this).attr('id') + 'Paging" align="center" class="search-for"></div>');
                    queue = '#' + jQuery(this).attr('id') + 'Paging';
                    jQuery(queue).append('<p class="paging"><a id="prePage" tableid="' + jQuery(this).attr('id') + '" pageindex=' + (parseInt(jQuery(this).data("pageindex")) - 1) + ' href="#">previous</a> | ' + (parseInt(jQuery(this).data("pageindex")) + 1) + '/' + allPage + ' | <a id="nextPage" tableid="' + jQuery(this).attr('id') + '" pageindex=' + (parseInt(jQuery(this).data("pageindex")) + 1) + ' href="#">next</a>&nbsp;&nbsp;Items per page:<input id="itemsPerPage" class="i_a" value="" onchange=changeItems() size="2" maxlength=2></p>');
                    jQuery("#" + jQuery(this).attr('id') + "Paging").find("#prePage").bind("click", settings, function (e) {
                        //                    var toPageIndex = settings.pageIndex - 1;
                        var toPageIndex = parseInt(jQuery(this).attr("pageindex"));
                        if (toPageIndex < 0) toPageIndex = allPage - 1;
                        jQuery("#" + jQuery(this).attr("tableid")).data("pageindex", toPageIndex);
                        jQuery("#" + jQuery(this).attr("tableid")).tablePaging(e.data);
                        e.preventDefault();
                    });
                    jQuery("#" + jQuery(this).attr('id') + "Paging").find("#nextPage").bind("click", settings, function (e) {
                        //var toPageIndex = settings.pageIndex + 1;
                        var toPageIndex = parseInt(jQuery(this).attr("pageindex"));
                        if (toPageIndex >= allPage) toPageIndex = 0;
                        jQuery("#" + jQuery(this).attr("tableid")).data("pageindex", toPageIndex);
                        jQuery("#" + jQuery(this).attr("tableid")).tablePaging(e.data);
                        e.preventDefault();
                    });
                //}
                //else {
                    //jQuery("#" + jQuery(this).attr('id') + "Paging").remove();
                //}

                if (jQuery.isFunction(settings.onPaged)) {
                    settings.onPaged();
                }
                $('#itemsPerPage').val(pageSize);
            });
        },
        
        simpleTableSort: function(sortBySelector, type, sortDirection){
        	var trs = jQuery(this).find('tr');
        	var tmp = [];
        	for (var i = 1; i < trs.length; i++) {
                tmp.push(trs[i]);
            }
        	if (type == "number") {
                tmp.sort(function (a, b) {
                	var inta = Number($($(a).find("td").get(sortBySelector)).text().replace(/[^0-9]/g,''));
                    var intb = Number($($(b).find("td").get(sortBySelector)).text().replace(/[^0-9]/g,''));
                    var returnValue = 0;
                    if (inta > intb) returnValue = 1;
                    else if (inta < intb) returnValue = -1;
                    if (sortDirection == "desc") returnValue = -returnValue;
                    return returnValue;
                });
            }
            else if (type === "date") {
                tmp.sort(function (a, b) {
                	var inta = $($(a).find("td").get(sortBySelector)).text();
                	inta = inta.replace(/-/g,'').replace(/:/g,'').replace(' ','');
                	var intb = $($(b).find("td").get(sortBySelector)).text();
                	intb = intb.replace(/-/g,'').replace(/:/g,'').replace(' ','');
                    var returnValue = 0;
                    if (inta > intb) returnValue = 1;
                    else if (inta < intb) returnValue = -1;
                    if (sortDirection == "desc") returnValue = -returnValue;
                    return returnValue;
                });
            }
            else {
                tmp.sort(function (a, b) {
                    var stra = $($(a).find("td").get(sortBySelector)).text();
                    var strb = $($(b).find("td").get(sortBySelector)).text();
                    var returnValue = 0;
                    if (stra > strb) returnValue = 1;
                    else if (stra < strb) returnValue = -1;
                    if (sortDirection == "desc") returnValue = -returnValue;

                    return returnValue;
                });
            }
        	for (var i = 0; i < tmp.length; i++) {
                trs[i+1] = tmp[i];
            }
            
        	jQuery(this).empty();
            jQuery(this).append(trs);
            addEvent();
        },

        tableSort: function (sortBySelector, type, sortDirection, total) {
            //jQuery('#' + jQuery(this).attr('id')).find('tbody').each(function (i, element) {
            	var trs = jQuery(this).find('tr');
        		var data = [];
                var tmp = [];
                var pageIndex = 0;
                if(typeof(settings) != 'undefined'){
                	var pageIndex = parseInt(jQuery('#' + settings.id).data("pageindex"));
                }
                var j = 0;
                data.push(trs[0]);
                for (var i = 0; i < trs.length; i++) {
                	if(trs[i].id.indexOf('selectOnly') >= 0){
                		data.push(trs[i]);
                		if(j >= pageIndex * pageSize && j < (pageIndex + 1) * pageSize){
                			tmp.push(trs[i]);
                		}
                		j++;
                	}
                }
                if (type == "number") {
                    tmp.sort(function (a, b) {
                    	var inta = Number($($(a).find("td").get(sortBySelector)).text().replace(/[^0-9]/g,''));
                        var intb = Number($($(b).find("td").get(sortBySelector)).text().replace(/[^0-9]/g,''));
                        var returnValue = 0;
                        if (inta > intb) returnValue = 1;
                        else if (inta < intb) returnValue = -1;
                        if (sortDirection == "desc") returnValue = -returnValue;
                        return returnValue;
                    });
                }
                else if (type === "date") {
                    tmp.sort(function (a, b) {
                    	var inta = $($(a).find("td").get(sortBySelector)).text();
                    	inta = inta.replace(/-/g,'').replace(/:/g,'').replace(' ','');
                    	var intb = $($(b).find("td").get(sortBySelector)).text();
                    	intb = intb.replace(/-/g,'').replace(/:/g,'').replace(' ','');
                        var returnValue = 0;
                        if (inta > intb) returnValue = 1;
                        else if (inta < intb) returnValue = -1;
                        if (sortDirection == "desc") returnValue = -returnValue;
                        return returnValue;
                    });
                }
                else {
                    tmp.sort(function (a, b) {
                        var stra = $($(a).find("td").get(sortBySelector)).text();
                        var strb = $($(b).find("td").get(sortBySelector)).text();
                        var returnValue = 0;
                        if (stra > strb) returnValue = 1;
                        else if (stra < strb) returnValue = -1;
                        if (sortDirection == "desc") returnValue = -returnValue;

                        return returnValue;
                    });
                }
                //jQuery(this).empty();
                /*for (var i = 0; i < tmp.length; i++) {
                	trs[i] = tmp[i];
                }*/
                for(i =0; i < tmp.length; i++){
                	data[i + pageIndex * pageSize + 1] = tmp[i];
                }
                jQuery(this).empty();
                //alert(a);
                for (var i = 0; i < data.length; i++) {
                	jQuery(this).append(data[i]);
                	trId = data[i].id;
                	if(trId != ''){
                		num = trId.substring('selectOnly'.length,trId.length);
                		buildDetailArray(num);
                	}
                }
                addEvent();
            //});

        }

    })
})(jQuery);

function parseDate(date) {
    return Date.parse(convertDateFormat(date)); // from en-GB format to en-US format,must greater than 01/01/1970;
}

function convertDateFormat(value) {
    return value = value.toString().replace(/\-/g, '/').replace(/\./g, '/').replace(/\s/g, '/');
}
function simpleQueryRecvAccInfos(id){
	var i = 0;
	var index = $('#querySelect').val();
    var param = $('#queryInput').val();
    
	$('#'+id).find('tr').each(function () {
		$(this).show();
    	var targetText =  $($(this).find('td').get(index)).text(); 
			if(targetText.indexOf(param) == -1 && targetText != ""){
        	$(this).hide();
      	}				
	});
}
function queryRecvAccInfos(id, total){
	var index = $('#querySelect').val();
    var param = $('#queryInput').val();
	for(i = 0; i < total; i++){
		var queryTr = $('#selectOnly'+i.toString());
		var nextId = $('#selectOnly'+i.toString()).next("tr").attr("id");
		var pageIndex = 0;
		var temp = parseInt(jQuery('#' + id).data("pageindex"));
		if(!isNaN(temp)){
			pageIndex =  temp;
		}
		if(i >= pageIndex * pageSize && i < (pageIndex + 1) * pageSize){
			$('#selectOnly'+i).show();
		}
		//Hide the detail info if it's explored
		if(!$('#' + nextId).is(":hidden")) {
			$('#' + nextId).slideToggle("fast"); 
		}
		var targetText = $($(queryTr).find("td").get(index)).text();
		if(targetText.indexOf(param) == -1 && targetText != ""){
            $('#selectOnly'+i).hide();
        }
	}
}	
function sortController(sortRow){
	var sortDirection = 'asc';
	var isAscHidden = $(sortRow).children(".asc").is(":hidden");
	var isDescHidden = $(sortRow).children(".desc").is(":hidden");
	$("th").children(".desc").hide();
	$("th").children(".asc").hide();
	if(!isAscHidden){
		sortDirection = 'desc';
		$(sortRow).children(".desc").show();
		//$(sortRow).children(".asc").hide();
	}
	else if(!isDescHidden){
		sortDirection = 'asc';
		$(sortRow).children(".asc").show();
		//$(sortRow).children(".desc").hide();
	}
	else{
		sortDirection = 'asc';
		$(sortRow).children(".asc").show();
	}
	return sortDirection;
}