import memcache  
import sys
import string
import os
import pwd
import time
from pywbem import *
from threadutil import *

class ProviderInfoTimeout(object):

    @timeout(90)
    def getProjiderInfo(self, className):
        cimInstances = cli.EnumerateInstances(className,'root/hpq')
        return cimInstances


mc = memcache.Client(['localhost:11211'],debug=0) 
limitation = 1000*900
cli = None
for dir in ["/var/run/tog-pegasus/socket/cimxml.socket", "/var/run/tog-pegasus/cimxml.socket"]:
    try:
        os.stat(dir)
        cli = WBEMConnection(dir)
    except :
        continue
    
if cli == None:
    cli = SFCBUDSConnection()
    
if cli == None:
    print 'Cannot establish a local connection!'
    sys.exit(2)

def mkjs(classNames):
    for className in classNames:
        #if className != 'SMX_PCIDevice':
	#	continue
	infoStr = ''
	infoList = []
        try:
            providerInfo = ProviderInfoTimeout()
            cimInstances = providerInfo.getProjiderInfo(className)
	except Timeout, e:
	    infoStr = '//Can not get data from Namespace:root/hpq Class:' + className + '\n'
            mc.set(className,str(infoStr))
            continue
            print e
	except:
            infoStr = '//Can not get data from Namespace:root/hpq Class:' + className + '\n'
            mc.set(className,str(infoStr))
            continue
        if len(cimInstances) == 0:
            infoStr = '//Can not get data from Namespace:root/hpq Class:' + className + '\n'
            mc.set(className,str(infoStr))
            continue
        i = 0
	infoList.append(cimInstances[0].classname)
	infoList.append('= new Array();')
        for cimInstance in cimInstances:
	    infoList.append(cimInstance.classname)
	    infoList.append('[')
	    infoList.append(str(i))
	    infoList.append('] = new Object();\n')
            for key, value in cimInstance.items():
                tmpvalue = ''
                import __builtin__
                if __builtin__.type(value) == list:
                    for a in value:
                        if tmpvalue == '':
                            tmpvalue = a
                        else:
                            tmpvalue = str(tmpvalue) + " " + str(a)
                else:
                    tmpvalue = value
                    tmpvalue = str(tmpvalue)
                    if tmpvalue.find('"') > -1:
                        tmpvalue = tmpvalue.replace('"','')     
                    if tmpvalue.find('\n') > -1:
                        tmpvalue = tmpvalue.replace('\n',' ')     
		infoList.append(cimInstance.classname)
		infoList.append('[')
		infoList.append(str(i))
		infoList.append('].')
		infoList.append(key)
		infoList.append('="')
		infoList.append(str(tmpvalue))
		infoList.append('";\n')
            i=i+1
	    #print(str(i))
	infoStr = ''.join(infoList)
	if len(infoStr) > limitation:
		temp = ''
		count = len(infoStr)/limitation
#		print str(count)
		mc.set(className, 'Overflow',3600)
		mc.set(className+'0',count+1,3600)
		for c in range(count):
			temp = infoStr[c*limitation: c*limitation+limitation]
			mc.set(className+str(c+1), temp, 3600)
	#		print temp
		temp = infoStr[count*limitation: len(infoStr)]
		mc.set(className+str(count+1), temp, 3600)
	#	print str(className+str(count+1))
	else:
        	mc.set(className,infoStr,3600)
        #print mc.get('SMX_PCIDevice5')
 
classNames = ['SMX_EthernetTeam','SMX_EthernetLANEndpoint','SMX_EthernetTeamMember',
                'SMX_EthernetPortToLANEndpoint','SMX_EthernetTeamToLANEndpoint','SMX_IPBindsToEthernetLANEndpoint',
                'SMX_EthernetMemberOfCollection','SMX_IPProtocolEndpoint','SMX_BladeEnclosureCollection',
                'SMX_EthernetControllerLocation','SMX_EthernetPortController','SMX_EthernetPortControllerEthernetPort',
                'SMX_EthernetPortStatisticalData','SMX_EthernetLANEndpointStatisticalData','SMX_EthernetStatistics',
                'SMX_BladeEnclosureCS','SMX_BladeCSLocation','SMX_ProcessorChip',
                'SMX_Processor','SMX_RealizesProcessor','SMX_CacheMemory',
                'SMX_ProcessorCollection','SMX_ProcessorCapabilities','SMX_HardwareThread',
                'SMX_ProcessorElementCapabilities','SMX_ProcessorElementLocation','SMX_ProcessorLocation',
                'SMX_Fan','SMX_FanModule','SMX_FanCollection',
                'SMX_FanRedundancySet','SMX_MemberOfFanRedundancy','SMX_FanInSlot',
                'SMX_FanSlot','SMX_FanElementLocation','SMX_FanLocation',
                'SMX_SystemFirmware','SMX_NumericSensor','SMX_SensorCollection',
                'SMX_Memory','SMX_MemoryModule','SMX_MemoryBoard',
                'SMX_MemoryCollection','SMX_MemoryModuleSlot','SMX_MemoryModuleInSlot',
                'SMX_MemoryBoardSlot','SMX_MemoryBoardInSlot','SMX_MemoryModuleSlotOnBoard',
                'SMX_ComputerSystemChassis','SMX_ManagementProcessor','SMX_MPCollection',
                'SMX_MPFirmware','SMX_MPMemberOfCollection','SMX_PCIDevice',
                'SMX_PCISlot','SMX_PCICardInSlot','SMX_RealizesPCIDevice',
                'SMX_PCICard','SMX_PowerSupply','SMX_PowerSupplyModule',
                'SMX_PowerCollection','SMX_PowerRedundancySet','SMX_MemberOfPowerRedundancy',
                'SMX_PowerSupplyElementLocation','SMX_PowerSupplyLocation','SMX_MemberOfPowerCollection',
                'SMX_SMXSoftwareIdentity',
                'SMX_ComputerSystem','SMX_OperatingSystem','SMX_SAArraySystem',
                'SMX_SAProduct','SMX_SAArrayController','SMX_SAArrayControllerPhysicalPackage',
                'SMX_SAArrayControllerLocation','SMX_SAArrayControllerPhysicalPackageArrayControllerLocation','SMX_FCHBAPhysicalPackage',
                'SMX_FCHBAGroupSystemSpecificCollection','SMX_FCHBAFirmwareIdentityFW','SMX_FCHBAFirmwareIdentityBIOS',
                'SMX_FCHBAFCPort','SMX_FCHBALocation','SMX_SADiskDrive',
                'SMX_SAStorageVolume','SMX_SAStorageVolumeStorageSetting','SMX_SAStorageEnclosureProcessor',
                'SMX_SAArraySystemStorageEnclosureProcessor','SMX_SAStorageEnclosure','SMX_SAStorageExtent',
                'SMX_SADiskDriveFirmware','SMX_SADiskPhysicalPackage','SMX_SAStorageExtentStorageVolume',
                'SMX_SAStorageSetting','SMX_SAStorageRedundancySetStorageExtent','SMX_SASpareExtentStorageRedundancySet',
                'SMX_SAMediaAccessStatData','SMX_SADiskDriveLocation','SMX_SADiskPhysicalPackageDiskDriveLocation',
                'SMX_SADiskDriveStorageExtent','SMX_SAStorageRedundancySet','SMX_SAEnclosureFirmware',
                'SMX_SADriveCage', 'SMX_EthernetPort', 'SMX_ServerProduct']
 
mkjs(classNames)
