﻿
function cmpAZ(prop,a,b)
{
   if (a[prop]>b[prop]) return 1;
   if (a[prop]<b[prop]) return -1;
   return 0;
}

function cmpNum(prop,a,b) { return a[prop]-b[prop]; }

function lineupNum(num) { return " "+(1000000000+parseInt(num,10)); }

function powerCmp(prop,a,b)
{
   if (typeof(re)=='undefined') { re=/ -?\d+/gi;}
   var a1=(typeof(a[prop])=='undefined')?"a":a[prop].toString().toUpperCase().replace(re,lineupNum);
   var b1=(typeof(b[prop])=='undefined')?"a":b[prop].toString().toUpperCase().replace(re,lineupNum);
   if (a1>b1) return 1;
   if (a1<b1) return -1;
   return 0;
}

var TimeoutRefresh1=null;
var nullNode=document.createElement("span");

function parseDateLocal(wmiDate)
{
   var regExpDate = /^(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)\.(\d\d\d\d\d\d)(.*)$/;
   var myMatch = regExpDate.exec(wmiDate);
   var fullDate;
   if (myMatch != null)
   {
      var myDate = new Date();
      myDate.setFullYear(myMatch[1],myMatch[2]-1,myMatch[3]); /* Month is 0 - 11 in Javascript */
      myDate.setHours(myMatch[4],myMatch[5],myMatch[6],myMatch[7]);
      fullDate=myDate.toLocaleString().toString();
      fullDate=fullDate.replace(/(:00 )/gi, " ");
   }
   else
   {
      fullDate=wmiDate;
   }
   return fullDate;
}

function parseDateFancy(wmiDate)
{
   var isIE = document.all?true:false;
   var fullDate = parseDateLocal(wmiDate);
   var regExpDay = /^(\w+),\s(\w+\s\d+,\s\d\d\d\d)\s(.*)$/i;
   var myMatch = regExpDay.exec(fullDate);
   var hiddenDayDate;
   if (myMatch != null)
   {
      var day = myMatch[1];
      var date = myMatch[2];
      var time = myMatch[3];
      hiddenDayDate = '<a title="'+(isIE?(date+' \n '+time+' '+day):fullDate)+'">'+date+' '+time+'</a>';
   }
   else
   {
      hiddenDayDate=fullDate;
   }
   return hiddenDayDate;      
}

function refresh()
{
   document.body.appendChild(nullNode);
   TimeoutRefresh1=null;
}

function setRefresh(delay)
{
   if (TimeoutRefresh1!=null){window.clearTimeout(TimeoutRefresh1)};
 	TimeoutRefresh1=window.setTimeout("refresh()",delay);
}

function refreshTable()
{
 	tb=this.getElementsByTagName("table");
 	for (var i=0;i<tb.length;i++)
 	{
 	   if (tb[i].floating) { tb[i].style.top=this.scrollTop+"px"; };
 	}
 	setRefresh(250);
}

function toggleClass(o,c1)
{
    var re = new RegExp(c1);
    o.className=re.test(o.className)?o.className.replace(c1,''):o.className+' '+c1;
}

function swapAddSort(o,what,c1,c2,prev)
{
   var table, list, func, sim;
   table = o.Container;
   list = o.sortarray;
   func = o.sortfunc;
   sim = o.image;
   var re2 = new RegExp(c2);  
   var m = re2.exec(sim[what]);
   if (m == null) 
   {
      var re1 = new RegExp(c1);
      m = re1.exec(sim[what]);
      if (m == null)
      {
         sim[what+'old']=sim[what];
         sim[what]=c1;
         if (table[prev] != null)
         {
            table[prev][what]=table[prev][what+'old'];
         }
         table[prev]=sim;
         eval("list.sort("+func+")");
      }
      else
      {
         sim[what]=sim[what].replace(c1,c2);
         list.reverse();
      }
   }
   else
   {
      sim[what]=sim[what].replace(c2,c1);
      list.reverse();
   }
   for (var i=0;i<list.length;i++)
   {
      list[i].htmlDisplay.className=(i%2==0)?list[i].htmlDisplay.className.replace('rowB','rowA'):list[i].htmlDisplay.className.replace('rowA','rowB');
      table.appendChild(list[i].htmlDisplay);
   }
}

function hlrow(o)
{
   o.className=/hl/.test(o.className)?o.className.replace('hl',''):o.className+' hl';
}

function ClassOn(o,cl)
{
   o.className=o.className+' '+cl;
}

function ClassOff(o,cl)
{
   o.className=o.className.replace(cl,'');
}

function toggleselectrow(o)
{
   o.className=/selectRow/.test(o.className)?o.className.replace('selectRow',''):o.className+' selectRow';
}

function getFullSize(str)
{
   var testDraw=document.getElementById('testDraw');
   testDraw.innerHTML=str;
   return testDraw.clientWidth;
}

function AddDynamicTable(objData,objDataTemplate,height,paddingSz,reSz,borderSz,vborderSz)
{
// Main table
   var isIE = document.all?true:false;
   var bcol = "#ccc";
   var fcol = "#948e8c";
   var imW = 14;
   var imPad = 0;
   var TprevW1=0;
   var heightrz = height-24;
 	var box=document.createElement('div');
 	
 	box.style.cssText="position:relative;overflow:auto;height:"+height+"px;border:inset 1px "+fcol+";";
 	box.style.display="inline-block";
 	box.style.width="100%";
 	box.onscroll=refreshTable;
 	box.ondblclick=refreshTable;
   var bw = borderSz; // td border-width
   var pd = paddingSz; // ell padding-left
   box.innerHTML="";
   
   var T1=document.createElement('table');
   T1.cellpadding=0; T1.cellspacing=0; T1.style.position="absolute"; T1.style.background="white"; T1.style.zIndex="1";
   var T1thead=document.createElement("thead");
   T1.appendChild(T1thead);
   T1.style.left="0px";
   T1.style.top="0px"; 
   T1.style.borderBottom="solid 0px black";
   T1.style.borderCollapse="collapse";
   T1.style.tableLayout="fixed";
   T1.style.backgroundColor=bcol;
   T1.floating=true;

   var T3=document.createElement('table');
   T3.cellpadding=0; T3.cellspacing=0; T3.style.position="absolute"; T3.style.zIndex="2"; T3.style.visibility="hidden";
   var T3tbody=document.createElement("tbody");
   T3.appendChild(T3tbody);
   T3.style.left="0px";
   T3.style.top="0px"; 
   T3.style.borderCollapse="collapse";
   T3.style.tableLayout="fixed";
   T3.style.emptyCells="show";
   T3.style.textAlign="left";
   T3.floating=true;

   var T2=document.createElement("table");
   T2.cellpadding=0; T2.cellspacing=0; T2.style.position="absolute";  T2.style.zIndex="0";//T2.style.background="white";
   T2.style.borderCollapse="collapse";
   T2.style.tableLayout="fixed";
   T2.style.left="0px";
   T2.style.top="0px";
   T2.style.borderBottom="solid 1px "+bcol;
   T2.style.backgroundColor=fcol;
   T2.floating=false;

   var T2tr=document.createElement("tr");
   T2tr.style.visibility="visible";
   var T2thead=document.createElement("thead");   
   T2.appendChild(T2thead); T2thead.appendChild(T2tr);

   box.appendChild(T1);
   box.appendChild(T2);
   box.appendChild(T3);
   
   var T3tr=document.createElement("tr");
   T3tbody.appendChild(T3tr);

   var T1tr=document.createElement("tr");
   var T2tbody=document.createElement("tbody");
   T2.appendChild(T2tbody);
   T1thead.appendChild(T1tr);

   var trs=new Array();
   var maxW=new Array();
   var maxText=new Array();
   var testDraw=document.getElementById('testDraw');
   nullNode=testDraw;
   var j=0;
   for (var i=0;i<objData.length;i++)
   {
      var TR=document.createElement("tr");
      trs.push(TR);
      var addclass=i%2==0?' rowA':' rowB'; TR.className=TR.className+addclass;
      T2tbody.appendChild(TR);
      var j=0;
      for (prop in objDataTemplate)
      {
         var td = document.createElement("td");
         var dv = document.createElement("span");
         dv.style.cssText="text-indent:"+paddingSz+"px;";
         dv.className="ell";
         dv.innerHTML=objData[i].hasOwnProperty(prop)?objDataTemplate[prop].show(objData[i]):"&nbsp;";
         td.style.cssText=
         "border-left:solid "+bw+"px "+bcol+
         ";border-right:solid "+bw+"px "+bcol+
         ";border-bottom:solid "+vborderSz+"px "+bcol+
         ";border-top:solid "+vborderSz+"px "+bcol+";";
         td.appendChild(dv);
         TR.appendChild(td);
         testDraw.innerHTML=dv.innerHTML;
         if (i==0) {maxW[j]=testDraw.clientWidth;maxText[j]=dv;}
         if (maxW[j]<testDraw.clientWidth) {maxW[j]=testDraw.clientWidth;maxText[j]=dv;}
         j++;
      }
      TDtmp = document.createElement("td");
//      TDtmp.innerHTML = "&nbsp;";
      TR.appendChild(TDtmp);
      objData[i].htmlDisplay=TR;
      TR.onmouseover=function(){ClassOn(this,'hl');};
      TR.onmouseout=function(){ClassOff(this,'hl');};
      /*TR.onclick=function(){toggleselectrow(this);};*/
   }
   j=0;

   k=0;
   var lasp=null;
   for (var prop in objDataTemplate)
   {
      var displayName = prop;
      if (objDataTemplate[prop].Title) {
         displayName=objDataTemplate[prop].Title;
      }
      var colAlign = "center";
      if (objDataTemplate[prop].align) {
         colAlign = objDataTemplate[prop].align;
      }
      
      var T2tdTopRow=document.createElement("td");
      T2tdTopRow.innerHTML="!";
      T2tdTopRow.style.cssText=
         ";border-bottom:solid 3px "+fcol+
         ";border-top:solid 3px "+fcol+
         ";border-left:solid "+bw+"px "+bcol+
         ";border-right:solid "+bw+"px "+bcol+
         ";visibility:hidden;";
      T2tr.appendChild(T2tdTopRow);

      var T1tdTopRow = document.createElement('td');
      T1tdTopRow.style.cssText=
         "border-right:solid "+(k==maxW.length-1?bw:0)+"px "+bcol+
         ";border-left:solid "+(bw-(k==0?1:0))+"px "+bcol+";";
      var tha = document.createElement('a');
      T1tdTopRow.appendChild(tha);
      tha.style.cssText = 'z-index:5;padding:0px 0px 0px 0px;border-right:solid 0px '+bcol+';position:relative;';
      tha.setAttribute("href","#");
      tha.className="sort ell";
      var b = document.createElement("b");
      b.appendChild(document.createTextNode(displayName));
      var backImg=document.createElement('img');
      backImg.src="/images/blank.gif";
      backImg.width=imW;
      backImg.height=6;
      backImg.style.cssText="border-width:0px;vertical-align:middle;";
      tha.appendChild(b);
      tha.appendChild(backImg);
      tha.onclick = function(e){swapAddSort(this,'src','/images/up_White.gif','/images/down_White.gif','selected1');return false;};
      tha.style.textAlign="center";
      tha.sortarray=objData;
      tha.Container=T2tbody;
      tha.sortfunc=objDataTemplate[prop].cmp;
      tha.image=document.createElement('img');
      tha.image.src="/images/blank.gif";
      tha.image.width=imW;
      tha.image.height=6;
      tha.image.style.cssText="border-width:0px;vertical-align:middle;";
      tha.insertBefore(tha.image,tha.firstChild);
      
      var headIsLargest = false;
      var thaOffsetW=(isIE?-bw+(k==0?1+(1-bw)/2:0)+(k==maxW.length-1?(1-bw)/2:0):2);
      var T3tdTopRowOffsetW=(k==0?-reSz-bw/2:0);
      var tdtextOffsetW=-paddingSz-(isIE?bw:0);
      testDraw.innerHTML=tha.innerHTML;
      var compareW = testDraw.clientWidth-thaOffsetW+tdtextOffsetW;
      if (maxW[k]<compareW) {maxW[k]=compareW;maxText[k]=tha;headIsLargest = true;};
      columnW=maxW[k]+paddingSz*2+(isIE?bw:0);
      
      sp=document.createElement("div");
      sp.maxText = maxText[k];
      sp.ra=new Array();
      sp.dra=new Array();
      sp.className="dragresize";
      sp.UNSELECTABLE="on";
      sp.style.height=heightrz+"px";
      sp.style.width=2*reSz+(isIE?0:-1)+(k==maxW.length-1?-reSz:0)+"px";
      sp.innerHTML="";

      var T3tdTopRow=document.createElement("td");
      T3tdTopRow.style.cssText=
         "border-left:solid "+bw+"px "+bcol+
         ";border-right:solid "+bw+"px "+bcol+";";
      if (lasp) {T3tdTopRow.appendChild(lasp);};
      lasp=sp;
      
      sp.maxOffsetW = tdtextOffsetW+(isIE?bw:0);

      tha.prevW=columnW+thaOffsetW;
      sp.ra.push(tha);

      T1tdTopRow.prevW=columnW;
      sp.ra.push(T1tdTopRow);

      T3tdTopRow.prevW=columnW+T3tdTopRowOffsetW;
      sp.ra.push(T3tdTopRow);

      T2tdTopRow.prevW=columnW+((isIE && k==0)?1:0);
      sp.dra.push(T2tdTopRow);

      T1tr.appendChild(T1tdTopRow);
      T3tr.appendChild(T3tdTopRow);

      for (m=0;m<trs.length;m++)
      {
         tdtext=trs[m].getElementsByTagName('td')[k].getElementsByTagName('span')[0];
         tdtext.style.overflow="hidden";
         tdtext.style.textAlign=colAlign;

         tdtext.prevW=columnW+tdtextOffsetW;
         sp.dra.push(tdtext);
      }

      for (q=0;q<sp.ra.length;q++)
      {
         sp.ra[q].style.width=sp.ra[q].prevW+"px";
      }
      for (q=0;q<sp.dra.length;q++)
      {
         sp.dra[q].style.width=sp.dra[q].prevW+"px";
      }
      TprevW1=TprevW1 + columnW;
      /*sp.ra.push(T1);sp.dra.push(T2); /* resizes the internal table instead */
      sp.ra.push(T3);

      sp.onmouseover=function(){ClassOn(this,'showdrag');};
      sp.onmouseout=function(){ClassOff(this,'showdrag');};
      if (objDataTemplate[prop].minWidth) {
         sp.minWidth = objDataTemplate[prop].minWidth+paddingSz;
      } else {
         sp.minWidth = 10+paddingSz;
      }
      sp.onmousedown=function(e){setResizeX(this.ra,this.dra,this.minWidth,e);return false;};
      sp.ondblclick =
      function(e) {
         setResizeX(this.ra,this.dra,this.minWidth,e);
         var dx=getFullSize(this.maxText.innerHTML)-(this.maxText.prevW+this.maxOffsetW);
         endResizeX(Math.abs(dx)<2?-1000:dx);
         return false;
      };
      k++;
   }
   var T3tdTopRowLast=document.createElement("td");
   T3tdTopRowLast.style.width=reSz;
   T3tdTopRowLast.appendChild(sp);
   T3tr.appendChild(T3tdTopRowLast);

   TDtmp = document.createElement("td");
   endTmp = document.createElement("div");
   endTmp.style.cssText="color:"+fcol+";background-color:"+fcol+";border-top:solid 3px "+fcol+";border-bottom:solid 3px "+fcol+";";
   endTmp.style.width="100%";
   endTmp.style.height="100%";
   endTmp.innerHTML="";
   TDtmp.appendChild(endTmp);
   T1tr.appendChild(TDtmp);

   /*T1.prevW=TprevW1; T2.prevW=TprevW1; T1.style.width=T1.prevW+"px"; T2.style.width=T2.prevW+"px"; /* resizes the internal table instead */
   T3.prevW=TprevW1; T3.style.width=T3.prevW+"px";
   T1.style.width="100%"; T2.style.width="100%"; /* leave internal table at 100% to avoid white space */
   return box;
}
